<template>
  <component
    :is="component"
    :data="data"
    :column="column"
    :is-pending="isPending"
    :data-qa="dataQa"
    :value-type="valueType"
    :class="isFocus ? 'isFocus' : 'notIsFocus'"
    @change-focus-state="onFocusStateChanged"
    @on-field-modified="onModified"
    @reset-state="resetFieldState"
  />
</template>

<script>
import TableRowSelect from './tableRowSelect'
import TableRowInput from './tableRowInput'
import TableRowCheckbox from './tableRowCheckbox'
import TableRowDatepicker from './tableRowDatepicker'

export default {
  name: 'EditableFields',
  components: {
    TableRowSelect,
    TableRowInput,
    TableRowCheckbox,
    TableRowDatepicker
  },
  props: {
    data: {
      type: Object,
      required: true
    },
    column: {
      type: Object,
      required: true
    },
    isPending: {
      type: Boolean,
      default: false
    },
    isFocus: {
      type: Boolean,
      default: false
    },
    dataQa: {
      type: String
    }
  },
  data () {
    return {
      isModified: false
    }
  },
  computed: {
    valueType () {
      return this.data.item.valueType || this.column.valueType || 'TEXT'
    },
    component () {
      switch (this.valueType) {
        case 'CHECKLIST':
        case 'CHECKLIST_LIST':
          return TableRowSelect

        case 'BOOLEAN':
          return TableRowCheckbox

        case 'DATE':
        case 'DATETIME':
          return TableRowDatepicker

        default:
          return TableRowInput
      }
    }
  },
  methods: {
    onFocusStateChanged (data) {
      this.$emit('change-focus-state', data)
    },
    onModified () {
      this.isModified = true
    },
    resetFieldState () {
      this.isModified = false
    }
  }
}
</script>
